Add x710 and xl710 tests for testpmd 98/5098/22
authorTibor Frank <tifrank@cisco.com>
Fri, 10 Feb 2017 08:24:00 +0000 (09:24 +0100)
committerPeter Mikus <pmikus@cisco.com>
Mon, 3 Apr 2017 09:46:36 +0000 (09:46 +0000)
10ge2p1x710-eth-l2xcbase-ndrdisc
40ge2p1xl710-eth-l2xcbase-ndrdisc

Change-Id: Iea411182fd41e1ae9ed9b5a17f540befc247adb9
Signed-off-by: Tibor Frank <tifrank@cisco.com>
bootstrap-TLDK.sh
dpdk-tests/dpdk_scripts/cleanup_dpdk.sh
dpdk-tests/dpdk_scripts/init_dpdk.sh
dpdk-tests/dpdk_scripts/install_dpdk.sh
dpdk-tests/dpdk_scripts/run_l2fwd.sh
dpdk-tests/perf/10ge2p1x520-eth-l2xcbase-testpmd-ndrpdrdisc.robot [moved from dpdk-tests/perf/10ge2p1x520-eth-l2xcbase-testpmd-ndrdisc.robot with 100% similarity]
dpdk-tests/perf/10ge2p1x710-eth-l2xcbase-testpmd-ndrpdrdisc.robot [new file with mode: 0644]
dpdk-tests/perf/40ge2p1xl710-eth-l2xcbase-testpmd-ndrpdrdisc.robot [new file with mode: 0644]
dpdk-tests/perf/__init__.robot
resources/libraries/python/TrafficGenerator.py

index 18ac2ed..df5c028 100755 (executable)
@@ -31,7 +31,7 @@ VIRL_SERVER_EXPECTED_STATUS="PRODUCTION"
 
 SSH_OPTIONS="-i ${VIRL_PKEY} -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null -o BatchMode=yes -o LogLevel=error"
 
-DPDK_VERSION=16.07
+DPDK_VERSION=17.02
 DPDK_DIR=dpdk-${DPDK_VERSION}
 DPDK_PACKAGE=${DPDK_DIR}.tar.xz
 
@@ -131,7 +131,7 @@ fi
 VIRL_DIR_LOC="/tmp"
 TLDK_TAR_FILE="tldk_depends.tar.gz"
 
-tar zcf ${TLDK_TAR_FILE} dpdk-16.07.tar.xz ./tldk/ \
+tar zcf ${TLDK_TAR_FILE} dpdk-17.02.tar.xz ./tldk/ \
     ./TLDK-tests/tldk_testconfig/ ./TLDK-tests/tldk_deplibs/
 
 cat ${VIRL_PKEY}
index c4d0828..3533a1a 100755 (executable)
@@ -1,54 +1,63 @@
 #!/bin/bash
 
+set -x
+
+# Setting variables
+DPDK_VERSION=dpdk-17.02
 ROOTDIR=/tmp/openvpp-testing
+TESTPMDLOG=screenlog.0
 PWDDIR=$(pwd)
 
-TESTPMD_LOG=/tmp/testpmd.log
-TESTPMD_PID=/tmp/testpmd.pid
-
+# Setting command line arguments
 port1_driver=$1
 port1_pci=$2
 port2_driver=$3
 port2_pci=$4
 
-#kill the dpdk application
+# Try to kill the testpmd
 sudo pgrep testpmd
 if [ $? -eq "0" ]; then
     success=false
-    sudo pkill tail
     sudo pkill testpmd
+    echo "RC = $?"
     for attempt in {1..5}; do
+        echo "Checking if testpmd is still alive, attempt nr ${attempt}"
         sudo pgrep testpmd
         if [ $? -eq "1" ]; then
+            echo "testpmd is dead"
             success=true
             break
         fi
+        echo "testpmd is still alive, waiting 1 second"
         sleep 1
     done
     if [ "$success" = false ]; then
         echo "The command sudo pkill testpmd failed"
+        sudo pkill -9 testpmd
+        echo "RC = $?"
         exit 1
     fi
-    cat ${TESTPMD_LOG}
+else
+    echo "testpmd is not running"
 fi
 
-sudo rm -f ${TESTPMD_LOG}
-sudo rm -f ${TESTPMD_PID}
+# Remove hugepages
 sudo rm -f /dev/hugepages/*
 
-cd ${ROOTDIR}/dpdk-16.07/
-./tools/dpdk-devbind.py -b ${port1_driver} ${port1_pci}
-./tools/dpdk-devbind.py -b ${port2_driver} ${port2_pci}
+# Unbind interfaces
+cd ${ROOTDIR}/${DPDK_VERSION}/
+sudo ./usertools/dpdk-devbind.py -b ${port1_driver} ${port1_pci} || \
+    echo "Unbind ${port1_pci} failed" || exit 1
+sudo ./usertools/dpdk-devbind.py -b ${port2_driver} ${port2_pci} || \
+    echo "Unbind ${port1_pci} failed" || exit 1
 
 sleep 2
 
-if1_name=`./tools/dpdk-devbind.py --s | grep "${port1_pci}" | sed -n 's/.*if=\(\S\)/\1/p' | awk -F' ' '{print $1}'`
-if2_name=`./tools/dpdk-devbind.py --s | grep "${port2_pci}" | sed -n 's/.*if=\(\S\)/\1/p' | awk -F' ' '{print $1}'`
-
-ifconfig ${if1_name} up
-ifconfig ${if2_name} up
+if1_name=`./usertools/dpdk-devbind.py --s | grep "${port1_pci}" | sed -n 's/.*if=\(\S\)/\1/p' | awk -F' ' '{print $1}'`
+if2_name=`./usertools/dpdk-devbind.py --s | grep "${port2_pci}" | sed -n 's/.*if=\(\S\)/\1/p' | awk -F' ' '{print $1}'`
 
-rmmod igb_uio
-rmmod uio
+# Remove igb_uio driver
+rmmod igb_uio || \
+    echo "Removing igb_uio failed" || exit 1
 
 cd ${PWDDIR}
index b0bd426..9870f49 100755 (executable)
@@ -1,17 +1,35 @@
 #!/bin/bash
 
+set -x
+
+# Setting variables
+DPDK_VERSION=dpdk-17.02
 ROOTDIR=/tmp/openvpp-testing
 PWDDIR=$(pwd)
+cd ${ROOTDIR}/${DPDK_VERSION}/
 
-cd ${ROOTDIR}/dpdk-16.07/
 modprobe uio
+echo "RC = $?"
+
 lsmod | grep igb_uio
-if [ $? -eq 1 ];
+if [ $? -ne 1 ];
+then
+    rmmod igb_uio || \
+        echo "Failed to remove igb_uio module" || exit 1
+fi
+
+lsmod | grep uio_pci_generic
+if [ $? -ne 1 ];
 then
-    insmod ./x86_64-native-linuxapp-gcc/kmod/igb_uio.ko || exit 1
-else
-    rmmod igb_uio
-    insmod ./x86_64-native-linuxapp-gcc/kmod/igb_uio.ko || exit 1
+    rmmod uio_pci_generic || \
+        echo "Failed to remove uio_pci_generic module" || exit 1
 fi
-./tools/dpdk-devbind.py -b igb_uio $1 $2
+
+insmod ./x86_64-native-linuxapp-gcc/kmod/igb_uio.ko || \
+    echo "Failed to insert igb_uio module" || exit 1
+
+# Binding
+./usertools/dpdk-devbind.py -b igb_uio $1 $2 || \
+    echo "Failed to bind interface $1 and $2 to igb_uio" || exit 1
+
 cd ${PWDDIR}
index 99fa957..4b4c04a 100755 (executable)
@@ -1,31 +1,40 @@
 #!/bin/bash
 
-DPDK_VERSION=16.07
-DPDK_DIR=dpdk-${DPDK_VERSION}
-DPDK_PACKAGE=${DPDK_DIR}.tar.xz
+set -x
 
+# Setting variables
+DPDK_VERSION=dpdk-17.02
+DPDK_DIR=${DPDK_VERSION}
+DPDK_PACKAGE=${DPDK_DIR}.tar.xz
 ROOTDIR=/tmp/openvpp-testing
 PWDDIR=$(pwd)
 
-#download the DPDK package
-#compile and install the DPDK
+# Download the DPDK package
 cd ${ROOTDIR}
-wget -q "fast.dpdk.org/rel/${DPDK_PACKAGE}" || exit 1
-tar xJf ${DPDK_PACKAGE}
+wget "fast.dpdk.org/rel/${DPDK_PACKAGE}" || \
+    echo "Failed to download $DPDK_PACKAGE" || exit 1
+tar xJvf ${DPDK_PACKAGE} || \
+    echo "Failed to extract $DPDK_PACKAGE" || exit 1
+
+# Compile the DPDK
 cd ./${DPDK_DIR}
-make install T=x86_64-native-linuxapp-gcc -j || exit 1
+make install T=x86_64-native-linuxapp-gcc -j || \
+    echo "Failed to compile $DPDK_VERSION" || exit 1
 cd ${PWDDIR}
 
-#compile the l3fwd
+# Compile the l3fwd
 export RTE_SDK=${ROOTDIR}/${DPDK_DIR}/
 export RTE_TARGET=x86_64-native-linuxapp-gcc
 cd ${RTE_SDK}/examples/l3fwd
-make -j || exit 1
+make -j || \
+    echo "Failed to compile l3fwd" || exit 1
 cd ${PWDDIR}
 
-#check and setup the hugepages
+# Check and setup the hugepages
 SYS_HUGEPAGE=$(cat /sys/kernel/mm/hugepages/hugepages-2048kB/nr_hugepages)
+echo "  SYS_HUGEPAGE = ${SYS_HUGEPAGE}"
 if [ ${SYS_HUGEPAGE} -lt 4096 ]; then
+    echo "  It is not enough, should be at least 4096"
     MOUNT=$(mount | grep /mnt/huge)
     while [ "${MOUNT}" != "" ]
     do
@@ -37,13 +46,15 @@ if [ ${SYS_HUGEPAGE} -lt 4096 ]; then
     echo 2048 | sudo tee /sys/devices/system/node/node0/hugepages/hugepages-2048kB/nr_hugepages
     echo 2048 | sudo tee /sys/devices/system/node/node1/hugepages/hugepages-2048kB/nr_hugepages
 
+    echo "  Mounting hugepages"
     sudo mkdir -p /mnt/huge
-    sudo mount -t hugetlbfs nodev /mnt/huge/
-    test $? -eq 0 || exit 1
+    sudo mount -t hugetlbfs nodev /mnt/huge/ || \
+        echo "Failed to mount hugepages" || exit 1
 fi
 
-#check and set the max map count
+# Check and set the max map count
 SYS_MAP=$(cat /proc/sys/vm/max_map_count)
+
 if [ ${SYS_MAP} -lt 200000 ]; then
     echo 200000 | sudo tee /proc/sys/vm/max_map_count
 fi
index 3ddf4fd..80ed14a 100755 (executable)
@@ -1,52 +1,66 @@
 #!/bin/bash
 
+set -x
+
+# Setting variables
+DPDK_VERSION=dpdk-17.02
 ROOTDIR=/tmp/openvpp-testing
+TESTPMDLOG=screenlog.0
 PWDDIR=$(pwd)
 
-TESTPMD_LOG=/tmp/testpmd.log
-TESTPMD_PID=/tmp/testpmd.pid
-
+# Setting command line arguments
 cpu_corelist=$1
 nb_cores=$2
 queue_nums=$3
 jumbo_frames=$4
 
-#kill the testpmd
+# Try to kill the testpmd
 sudo pgrep testpmd
 if [ $? -eq "0" ]; then
     success=false
     sudo pkill testpmd
+    echo "RC = $?"
     for attempt in {1..5}; do
+        echo "Checking if testpmd is still alive, attempt nr ${attempt}"
         sudo pgrep testpmd
         if [ $? -eq "1" ]; then
+            echo "testpmd is dead"
             success=true
             break
         fi
+        echo "testpmd is still alive, waiting 1 second"
         sleep 1
     done
     if [ "$success" = false ]; then
         echo "The command sudo pkill testpmd failed"
+        sudo pkill -9 testpmd
+        echo "RC = $?"
         exit 1
     fi
+else
+    echo "testpmd is not running"
 fi
 
-sudo rm -f ${TESTPMD_LOG}
-sudo rm -f ${TESTPMD_PID}
+# Remove hugepages
 sudo rm -f /dev/hugepages/*
 
-#run the testpmd
-cd ${ROOTDIR}
+sleep 2
+
+cd ${ROOTDIR}/${DPDK_VERSION}/
+rm -f ${TESTPMDLOG}
 if [ "$jumbo_frames" = "yes" ]; then
-tail -f /dev/null | nohup ./dpdk-16.07/x86_64-native-linuxapp-gcc/app/testpmd -l ${cpu_corelist} \
-    -n 4 -- --numa --nb-ports=2 --portmask=0x3 --nb-cores=${nb_cores} \
-    --max-pkt-len=9000 --txqflags=0 --forward-mode=io --rxq=${queue_nums} \
-    --txq=${queue_nums} --auto-start > ${TESTPMD_LOG} 2>&1 &
-echo $! > ${TESTPMD_PID}
+    sudo sh -c "screen -dmSL DPDK-test ./x86_64-native-linuxapp-gcc/app/testpmd -l ${cpu_corelist} \
+        -n 4 -- --numa --nb-ports=2 --portmask=0x3 --nb-cores=${nb_cores} \
+        --max-pkt-len=9000 --txqflags=0 --forward-mode=io --rxq=${queue_nums} \
+        --txq=${queue_nums} --auto-start"
+    sleep 10
+    cat ${TESTPMDLOG}
 else
-tail -f /dev/null | nohup ./dpdk-16.07/x86_64-native-linuxapp-gcc/app/testpmd -l ${cpu_corelist} \
-    -n 4 -- --numa --nb-ports=2 --portmask=0x3 --nb-cores=${nb_cores} \
-    --forward-mode=io --rxq=${queue_nums} --txq=${queue_nums} --auto-start > ${TESTPMD_LOG} 2>&1 &
-echo $! > ${TESTPMD_PID}
+    sudo sh -c "screen -dmSL DPDK-test ./x86_64-native-linuxapp-gcc/app/testpmd -l ${cpu_corelist} \
+        -n 4 -- --numa --nb-ports=2 --portmask=0x3 --nb-cores=${nb_cores} \
+        --forward-mode=io --rxq=${queue_nums} --txq=${queue_nums} --auto-start"
+    sleep 10
+    cat ${TESTPMDLOG}
 fi
 
 cd ${PWDDIR}
diff --git a/dpdk-tests/perf/10ge2p1x710-eth-l2xcbase-testpmd-ndrpdrdisc.robot b/dpdk-tests/perf/10ge2p1x710-eth-l2xcbase-testpmd-ndrpdrdisc.robot
new file mode 100644 (file)
index 0000000..b7db75c
--- /dev/null
@@ -0,0 +1,420 @@
+# Copyright (c) 2016 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+#
+#     http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+*** Settings ***
+| Resource | resources/libraries/robot/performance.robot
+| Resource | resources/libraries/robot/DPDK/default.robot
+| Library | resources.libraries.python.topology.Topology
+| Library | resources.libraries.python.NodePath
+| Library | resources.libraries.python.InterfaceUtil
+| Library | resources.libraries.python.DPDK.DPDKTools
+| Force Tags | 3_NODE_SINGLE_LINK_TOPO | HW_ENV | PERFTEST | NDRPDRDISC | 1NUMA
+| ... | NIC_Intel-X710 | DPDK | ETH | L2XCFWD | BASE
+| Suite Setup | DPDK 3-node Performance Suite Setup with DUT's NIC model
+| ... | L2 | Intel-X710
+| Suite Teardown | DPDK 3-node Performance Suite Teardown
+| Documentation | *RFC2544: Pkt throughput IPv4 routing test cases*
+| ...
+| ... | *[Top] Network Topologies:* TG-DUT1-DUT2-TG 3-node circular topology\
+| ... | with single links between nodes.
+| ... | *[Enc] Packet Encapsulations:* Eth-IPv4 for L2 frame forwarding.
+| ... | *[Cfg] DUT configuration:* DUT1 and DUT2 run the DPDK testpmd\
+| ... | application and use the io forwarding mode. DUT1 and DUT2 tested with\
+| ... | 2p10GE NIC X710 Niantic by Intel.
+| ... | *[Ver] TG verification:* TG finds and reports throughput NDR (Non Drop\
+| ... | Rate) with zero packet loss tolerance or throughput PDR (Partial Drop\
+| ... | Rate) with non-zero packet loss tolerance (LT) expressed in percentage\
+| ... | of packets transmitted. NDR and PDR are discovered for different\
+| ... | Ethernet L2 frame sizes using either binary search or linear search\
+| ... | algorithms with configured starting rate and final step that determines\
+| ... | throughput measurement resolution. Test packets are generated by TG on\
+| ... | links to DUTs. TG traffic profile contains two L3 flow-groups\
+| ... | (flow-group per direction, 253 flows per flow-group) with all packets\
+| ... | containing Ethernet header, IPv4 header with IP protocol=61 and static\
+| ... | payload. MAC addresses are matching MAC addresses of the TG node\
+| ... | interfaces.
+| ... | *[Ref] Applicable standard specifications:* RFC2544.
+
+*** Variables ***
+# X520-DA2 bandwidth limit
+| ${s_limit} | ${10000000000}
+
+*** Test Cases ***
+| tc01-64B-1t1c-eth-l2xcbase-testpmd-ndrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 1 thread, 1 phy core,\
+| | ... | 1 receive queue per NIC port.
+| | ... | [Ver] Find NDR for 64 Byte frames using binary search start at 10GE\
+| | ... | linerate, step 100kpps.
+| | ...
+| | [Tags] | 1T1C | STHREAD | NDRDISC
+| | ...
+| | ${framesize}= | Set Variable | ${64}
+| | ${min_rate}= | Set Variable | ${100000}
+| | ${max_rate}= | Calculate pps | ${s_limit} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '1' worker threads and rxqueues '1' with jumbo frames 'no'
+| | Then Find NDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold}
+
+| tc02-64B-1t1c-eth-l2xcbase-testpmd-pdrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 1 thread, 1 phy core,\
+| | ... | 1 receive queue per NIC port.
+| | ... | [Ver] Find PDR for 64 Byte frames using binary search start at 10GE\
+| | ... | linerate, step 100kpps, LT=0.5%.
+| | ...
+| | [Tags] | 1T1C | STHREAD | PDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${64}
+| | ${min_rate}= | Set Variable | ${100000}
+| | ${max_rate}= | Calculate pps | ${s_limit} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '1' worker threads and rxqueues '1' with jumbo frames 'no'
+| | Then Find PDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold} | ${perf_pdr_loss_acceptance}
+| | ... | ${perf_pdr_loss_acceptance_type}
+
+| tc03-1518B-1t1c-eth-l2xcbase-testpmd-ndrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 1 thread, 1 phy core,\
+| | ... | 1 receive queue per NIC port.
+| | ... | [Ver] Find NDR for 1518 Byte frames using binary search start at 10GE\
+| | ... | linerate, step 10kpps.
+| | ...
+| | [Tags] | 1T1C | STHREAD | NDRDISC
+| | ...
+| | ${framesize}= | Set Variable | ${1518}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_limit} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '1' worker threads and rxqueues '1' with jumbo frames 'no'
+| | Then Find NDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold}
+
+| tc04-1518B-1t1c-eth-l2xcbase-testpmd-pdrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 1 thread, 1 phy core,\
+| | ... | 1 receive queue per NIC port.
+| | ... | [Ver] Find PDR for 1518 Byte frames using binary search start at 10GE\
+| | ... | linerate, step 10kpps, LT=0.5%.
+| | ...
+| | [Tags] | 1T1C | STHREAD | PDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${1518}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_limit} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '1' worker threads and rxqueues '1' with jumbo frames 'no'
+| | Then Find PDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold} | ${perf_pdr_loss_acceptance}
+| | ... | ${perf_pdr_loss_acceptance_type}
+
+| tc05-9000B-1t1c-eth-l2xcbase-testpmd-ndrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 1 thread, 1 phy core,\
+| | ... | 1 receive queue per NIC port.
+| | ... | [Ver] Find NDR for 9000 Byte frames using binary search start at 10GE\
+| | ... | linerate, step 10kpps.
+| | ...
+| | [Tags] | 1T1C | STHREAD | NDRDISC
+| | ...
+| | ${framesize}= | Set Variable | ${9000}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_limit} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '1' worker threads and rxqueues '1' with jumbo frames 'yes'
+| | Then Find NDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold}
+
+| tc06-9000B-1t1c-eth-l2xcbase-testpmd-pdrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 1 thread, 1 phy core,\
+| | ... | 1 receive queue per NIC port.
+| | ... | [Ver] Find PDR for 9000 Byte frames using binary search start at 10GE\
+| | ... | linerate, step 10kpps, LT=0.5%.
+| | ...
+| | [Tags] | 1T1C | STHREAD | PDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${9000}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_limit} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '1' worker threads and rxqueues '1' with jumbo frames 'yes'
+| | Then Find PDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold} | ${perf_pdr_loss_acceptance}
+| | ... | ${perf_pdr_loss_acceptance_type}
+
+| tc07-64B-2t2c-eth-l2xcbase-testpmd-ndrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 2 threads, 2 phy\
+| | ... | cores, 1 receive queue per NIC port.
+| | ... | [Ver] Find NDR for 64 Byte frames using binary search start at 10GE\
+| | ... | linerate, step 100kpps.
+| | ...
+| | [Tags] | 2T2C | MTHREAD | NDRDISC
+| | ...
+| | ${framesize}= | Set Variable | ${64}
+| | ${min_rate}= | Set Variable | ${100000}
+| | ${max_rate}= | Calculate pps | ${s_limit} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '2' worker threads and rxqueues '1' with jumbo frames 'no'
+| | Then Find NDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold}
+
+| tc08-64B-2t2c-eth-l2xcbase-testpmd-pdrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 2 threads, 2 phy\
+| | ... | cores, 1 receive queue per NIC port.
+| | ... | [Ver] Find PDR for 64 Byte frames using binary search start at 10GE\
+| | ... | linerate, step 100kpps, LT=0.5%.
+| | ...
+| | [Tags] | 2T2C | MTHREAD | PDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${64}
+| | ${min_rate}= | Set Variable | ${100000}
+| | ${max_rate}= | Calculate pps | ${s_limit} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '2' worker threads and rxqueues '1' with jumbo frames 'no'
+| | Then Find PDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold} | ${perf_pdr_loss_acceptance}
+| | ... | ${perf_pdr_loss_acceptance_type}
+
+| tc09-1518B-2t2c-eth-l2xcbase-testpmd-ndrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 2 threads, 2 phy\
+| | ... | cores, 1 receive queue per NIC port.
+| | ... | [Ver] Find NDR for 1518 Byte frames using binary search start at 10GE\
+| | ... | linerate, step 10kpps.
+| | ...
+| | [Tags] | 2T2C | MTHREAD | NDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${1518}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_limit} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '2' worker threads and rxqueues '1' with jumbo frames 'no'
+| | Then Find NDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold}
+
+| tc10-1518B-2t2c-eth-l2xcbase-testpmd-pdrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 2 threads, 2 phy\
+| | ... | cores, 1 receive queue per NIC port.
+| | ... | [Ver] Find PDR for 1518 Byte frames using binary search start at 10GE\
+| | ... | linerate, step 10kpps, LT=0.5%.
+| | ...
+| | [Tags] | 2T2C | MTHREAD | PDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${1518}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_limit} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '2' worker threads and rxqueues '1' with jumbo frames 'no'
+| | Then Find PDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold} | ${perf_pdr_loss_acceptance}
+| | ... | ${perf_pdr_loss_acceptance_type}
+
+| tc11-9000B-2t2c-eth-l2xcbase-testpmd-ndrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 2 threads, 2 phy\
+| | ... | cores, 1 receive queue per NIC port.
+| | ... | [Ver] Find NDR for 9000 Byte frames using binary search start at 10GE\
+| | ... | linerate, step 10kpps.
+| | ...
+| | [Tags] | 2T2C | MTHREAD | NDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${9000}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_limit} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '2' worker threads and rxqueues '1' with jumbo frames 'yes'
+| | Then Find NDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold}
+
+| tc12-9000B-2t2c-eth-l2xcbase-testpmd-pdrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 2 threads, 2 phy\
+| | ... | cores, 1 receive queue per NIC port.
+| | ... | [Ver] Find PDR for 9000 Byte frames using binary search start at 10GE\
+| | ... | linerate, step 10kpps, LT=0.5%.
+| | ...
+| | [Tags] | 2T2C | MTHREAD | PDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${9000}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_limit} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '2' worker threads and rxqueues '1' with jumbo frames 'yes'
+| | Then Find PDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold} | ${perf_pdr_loss_acceptance}
+| | ... | ${perf_pdr_loss_acceptance_type}
+
+| tc13-64B-4t4c-eth-l2xcbase-testpmd-ndrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 4 threads, 4 phy\
+| | ... | cores, 2 receive queues per NIC port.
+| | ... | [Ver] Find NDR for 64 Byte frames using binary search start at 10GE\
+| | ... | linerate, step 100kpps.
+| | ...
+| | [Tags] | 4T4C | MTHREAD | NDRDISC
+| | ...
+| | ${framesize}= | Set Variable | ${64}
+| | ${min_rate}= | Set Variable | ${100000}
+| | ${max_rate}= | Calculate pps | ${s_limit} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '4' worker threads and rxqueues '2' with jumbo frames 'no'
+| | Then Find NDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold}
+
+| tc14-64B-4t4c-eth-l2xcbase-testpmd-pdrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 4 threads, 4 phy\
+| | ... | cores, 2 receive queues per NIC port.
+| | ... | [Ver] Find PDR for 64 Byte frames using binary search start at 10GE\
+| | ... | linerate, step 100kpps, LT=0.5%.
+| | ...
+| | [Tags] | 4T4C | MTHREAD | PDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${64}
+| | ${min_rate}= | Set Variable | ${100000}
+| | ${max_rate}= | Calculate pps | ${s_limit} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '4' worker threads and rxqueues '2' with jumbo frames 'no'
+| | Then Find PDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold} | ${perf_pdr_loss_acceptance}
+| | ... | ${perf_pdr_loss_acceptance_type}
+
+| tc15-1518B-4t4c-eth-l2xcbase-testpmd-ndrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 4 threads, 4 phy\
+| | ... | cores, 2 receive queues per NIC port.
+| | ... | [Ver] Find NDR for 1518 Byte frames using binary search start at 10GE\
+| | ... | linerate, step 10kpps.
+| | ...
+| | [Tags] | 4T4C | MTHREAD | NDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${1518}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_limit} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '4' worker threads and rxqueues '2' with jumbo frames 'no'
+| | Then Find NDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold}
+
+| tc16-1518B-4t4c-eth-l2xcbase-testpmd-pdrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 4 threads, 4 phy\
+| | ... | cores, 2 receive queues per NIC port.
+| | ... | [Ver] Find PDR for 1518 Byte frames using binary search start at 10GE\
+| | ... | linerate, step 10kpps, LT=0.5%.
+| | ...
+| | [Tags] | 4T4C | MTHREAD | PDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${1518}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_limit} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '4' worker threads and rxqueues '2' with jumbo frames 'no'
+| | Then Find PDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold} | ${perf_pdr_loss_acceptance}
+| | ... | ${perf_pdr_loss_acceptance_type}
+
+| tc17-9000B-4t4c-eth-l2xcbase-testpmd-ndrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 4 threads, 4 phy\
+| | ... | cores, 2 receive queues per NIC port.
+| | ... | [Ver] Find NDR for 9000 Byte frames using binary search start at 10GE\
+| | ... | linerate, step 10kpps.
+| | ...
+| | [Tags] | 4T4C | MTHREAD | NDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${9000}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_limit} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '4' worker threads and rxqueues '2' with jumbo frames 'yes'
+| | Then Find NDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold}
+
+| tc18-9000B-4t4c-eth-l2xcbase-testpmd-pdrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 4 threads, 4 phy\
+| | ... | cores, 2 receive queues per NIC port.
+| | ... | [Ver] Find PDR for 9000 Byte frames using binary search start at 10GE\
+| | ... | linerate, step 5kpps, LT=0.5%.
+| | ...
+| | [Tags] | 4T4C | MTHREAD | PDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${9000}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_limit} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '4' worker threads and rxqueues '2' with jumbo frames 'yes'
+| | Then Find PDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold} | ${perf_pdr_loss_acceptance}
+| | ... | ${perf_pdr_loss_acceptance_type}
\ No newline at end of file
diff --git a/dpdk-tests/perf/40ge2p1xl710-eth-l2xcbase-testpmd-ndrpdrdisc.robot b/dpdk-tests/perf/40ge2p1xl710-eth-l2xcbase-testpmd-ndrpdrdisc.robot
new file mode 100644 (file)
index 0000000..d77018f
--- /dev/null
@@ -0,0 +1,422 @@
+# Copyright (c) 2016 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+#
+#     http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+*** Settings ***
+| Resource | resources/libraries/robot/performance.robot
+| Resource | resources/libraries/robot/DPDK/default.robot
+| Library | resources.libraries.python.topology.Topology
+| Library | resources.libraries.python.NodePath
+| Library | resources.libraries.python.InterfaceUtil
+| Library | resources.libraries.python.DPDK.DPDKTools
+| Force Tags | 3_NODE_SINGLE_LINK_TOPO | HW_ENV | PERFTEST | NDRPDRDISC | 1NUMA
+| ... | NIC_Intel-XL710 | DPDK | ETH | L2XCFWD | BASE
+| Suite Setup | DPDK 3-node Performance Suite Setup with DUT's NIC model
+| ... | L2 | Intel-XL710
+| Suite Teardown | DPDK 3-node Performance Suite Teardown
+| Documentation | *RFC2544: Pkt throughput IPv4 routing test cases*
+| ...
+| ... | *[Top] Network Topologies:* TG-DUT1-DUT2-TG 3-node circular topology\
+| ... | with single links between nodes.
+| ... | *[Enc] Packet Encapsulations:* Eth-IPv4 for L2 frame forwarding.
+| ... | *[Cfg] DUT configuration:* DUT1 and DUT2 run the DPDK testpmd\
+| ... | application and use the io forwarding mode. DUT1 and DUT2 tested with\
+| ... | 2p40GE NIC XL710 Niantic by Intel.
+| ... | *[Ver] TG verification:* TG finds and reports throughput NDR (Non Drop\
+| ... | Rate) with zero packet loss tolerance or throughput PDR (Partial Drop\
+| ... | Rate) with non-zero packet loss tolerance (LT) expressed in percentage\
+| ... | of packets transmitted. NDR and PDR are discovered for different\
+| ... | Ethernet L2 frame sizes using either binary search or linear search\
+| ... | algorithms with configured starting rate and final step that determines\
+| ... | throughput measurement resolution. Test packets are generated by TG on\
+| ... | links to DUTs. TG traffic profile contains two L3 flow-groups\
+| ... | (flow-group per direction, 253 flows per flow-group) with all packets\
+| ... | containing Ethernet header, IPv4 header with IP protocol=61 and static\
+| ... | payload. MAC addresses are matching MAC addresses of the TG node\
+| ... | interfaces.
+| ... | *[Ref] Applicable standard specifications:* RFC2544.
+
+*** Variables ***
+# XL710-DA2 bandwidth limit ~49Gbps/2=24.5Gbps
+| ${s_24.5G} | ${24500000000}
+# XL710-DA2 Mpps limit 37.5Mpps/2=18.75Mpps
+| ${s_18.75Mpps} | ${18750000}
+
+*** Test Cases ***
+| tc01-64B-1t1c-eth-l2xcbase-testpmd-ndrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 1 thread, 1 phy core,\
+| | ... | 1 receive queue per NIC port.
+| | ... | [Ver] Find NDR for 64 Byte frames using binary search start at 40GE\
+| | ... | linerate, step 100kpps.
+| | ...
+| | [Tags] | 1T1C | STHREAD | NDRDISC
+| | ...
+| | ${framesize}= | Set Variable | ${64}
+| | ${min_rate}= | Set Variable | ${100000}
+| | ${max_rate}= | Set Variable | ${s_18.75Mpps}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '1' worker threads and rxqueues '1' with jumbo frames 'no'
+| | Then Find NDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold}
+
+| tc02-64B-1t1c-eth-l2xcbase-testpmd-pdrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 1 thread, 1 phy core,\
+| | ... | 1 receive queue per NIC port.
+| | ... | [Ver] Find PDR for 64 Byte frames using binary search start at 40GE\
+| | ... | linerate, step 100kpps, LT=0.5%.
+| | ...
+| | [Tags] | 1T1C | STHREAD | PDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${64}
+| | ${min_rate}= | Set Variable | ${100000}
+| | ${max_rate}= | Set Variable | ${s_18.75Mpps}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '1' worker threads and rxqueues '1' with jumbo frames 'no'
+| | Then Find PDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold} | ${perf_pdr_loss_acceptance}
+| | ... | ${perf_pdr_loss_acceptance_type}
+
+| tc03-1518B-1t1c-eth-l2xcbase-testpmd-ndrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 1 thread, 1 phy core,\
+| | ... | 1 receive queue per NIC port.
+| | ... | [Ver] Find NDR for 1518 Byte frames using binary search start at 40GE\
+| | ... | linerate, step 10kpps.
+| | ...
+| | [Tags] | 1T1C | STHREAD | NDRDISC
+| | ...
+| | ${framesize}= | Set Variable | ${1518}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_24.5G} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '1' worker threads and rxqueues '1' with jumbo frames 'no'
+| | Then Find NDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold}
+
+| tc04-1518B-1t1c-eth-l2xcbase-testpmd-pdrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 1 thread, 1 phy core,\
+| | ... | 1 receive queue per NIC port.
+| | ... | [Ver] Find PDR for 1518 Byte frames using binary search start at 40GE\
+| | ... | linerate, step 10kpps, LT=0.5%.
+| | ...
+| | [Tags] | 1T1C | STHREAD | PDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${1518}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_24.5G} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '1' worker threads and rxqueues '1' with jumbo frames 'no'
+| | Then Find PDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold} | ${perf_pdr_loss_acceptance}
+| | ... | ${perf_pdr_loss_acceptance_type}
+
+| tc05-9000B-1t1c-eth-l2xcbase-testpmd-ndrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 1 thread, 1 phy core,\
+| | ... | 1 receive queue per NIC port.
+| | ... | [Ver] Find NDR for 9000 Byte frames using binary search start at 40GE\
+| | ... | linerate, step 10kpps.
+| | ...
+| | [Tags] | 1T1C | STHREAD | NDRDISC
+| | ...
+| | ${framesize}= | Set Variable | ${9000}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_24.5G} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '1' worker threads and rxqueues '1' with jumbo frames 'yes'
+| | Then Find NDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold}
+
+| tc06-9000B-1t1c-eth-l2xcbase-testpmd-pdrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 1 thread, 1 phy core,\
+| | ... | 1 receive queue per NIC port.
+| | ... | [Ver] Find PDR for 9000 Byte frames using binary search start at 40GE\
+| | ... | linerate, step 10kpps, LT=0.5%.
+| | ...
+| | [Tags] | 1T1C | STHREAD | PDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${9000}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_24.5G} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '1' worker threads and rxqueues '1' with jumbo frames 'yes'
+| | Then Find PDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold} | ${perf_pdr_loss_acceptance}
+| | ... | ${perf_pdr_loss_acceptance_type}
+
+| tc07-64B-2t2c-eth-l2xcbase-testpmd-ndrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 2 threads, 2 phy\
+| | ... | cores, 1 receive queue per NIC port.
+| | ... | [Ver] Find NDR for 64 Byte frames using binary search start at 40GE\
+| | ... | linerate, step 100kpps.
+| | ...
+| | [Tags] | 2T2C | MTHREAD | NDRDISC
+| | ...
+| | ${framesize}= | Set Variable | ${64}
+| | ${min_rate}= | Set Variable | ${100000}
+| | ${max_rate}= | Set Variable | ${s_18.75Mpps}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '2' worker threads and rxqueues '1' with jumbo frames 'no'
+| | Then Find NDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold}
+
+| tc08-64B-2t2c-eth-l2xcbase-testpmd-pdrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 2 threads, 2 phy\
+| | ... | cores, 1 receive queue per NIC port.
+| | ... | [Ver] Find PDR for 64 Byte frames using binary search start at 40GE\
+| | ... | linerate, step 100kpps, LT=0.5%.
+| | ...
+| | [Tags] | 2T2C | MTHREAD | PDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${64}
+| | ${min_rate}= | Set Variable | ${100000}
+| | ${max_rate}= | Set Variable | ${s_18.75Mpps}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '2' worker threads and rxqueues '1' with jumbo frames 'no'
+| | Then Find PDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold} | ${perf_pdr_loss_acceptance}
+| | ... | ${perf_pdr_loss_acceptance_type}
+
+| tc09-1518B-2t2c-eth-l2xcbase-testpmd-ndrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 2 threads, 2 phy\
+| | ... | cores, 1 receive queue per NIC port.
+| | ... | [Ver] Find NDR for 1518 Byte frames using binary search start at 40GE\
+| | ... | linerate, step 10kpps.
+| | ...
+| | [Tags] | 2T2C | MTHREAD | NDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${1518}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_24.5G} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '2' worker threads and rxqueues '1' with jumbo frames 'no'
+| | Then Find NDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold}
+
+| tc10-1518B-2t2c-eth-l2xcbase-testpmd-pdrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 2 threads, 2 phy\
+| | ... | cores, 1 receive queue per NIC port.
+| | ... | [Ver] Find PDR for 1518 Byte frames using binary search start at 40GE\
+| | ... | linerate, step 10kpps, LT=0.5%.
+| | ...
+| | [Tags] | 2T2C | MTHREAD | PDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${1518}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_24.5G} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '2' worker threads and rxqueues '1' with jumbo frames 'no'
+| | Then Find PDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold} | ${perf_pdr_loss_acceptance}
+| | ... | ${perf_pdr_loss_acceptance_type}
+
+| tc11-9000B-2t2c-eth-l2xcbase-testpmd-ndrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 2 threads, 2 phy\
+| | ... | cores, 1 receive queue per NIC port.
+| | ... | [Ver] Find NDR for 9000 Byte frames using binary search start at 40GE\
+| | ... | linerate, step 10kpps.
+| | ...
+| | [Tags] | 2T2C | MTHREAD | NDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${9000}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_24.5G} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '2' worker threads and rxqueues '1' with jumbo frames 'yes'
+| | Then Find NDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold}
+
+| tc12-9000B-2t2c-eth-l2xcbase-testpmd-pdrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 2 threads, 2 phy\
+| | ... | cores, 1 receive queue per NIC port.
+| | ... | [Ver] Find PDR for 9000 Byte frames using binary search start at 40GE\
+| | ... | linerate, step 10kpps, LT=0.5%.
+| | ...
+| | [Tags] | 2T2C | MTHREAD | PDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${9000}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_24.5G} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '2' worker threads and rxqueues '1' with jumbo frames 'yes'
+| | Then Find PDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold} | ${perf_pdr_loss_acceptance}
+| | ... | ${perf_pdr_loss_acceptance_type}
+
+| tc13-64B-4t4c-eth-l2xcbase-testpmd-ndrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 4 threads, 4 phy\
+| | ... | cores, 2 receive queues per NIC port.
+| | ... | [Ver] Find NDR for 64 Byte frames using binary search start at 40GE\
+| | ... | linerate, step 100kpps.
+| | ...
+| | [Tags] | 4T4C | MTHREAD | NDRDISC
+| | ...
+| | ${framesize}= | Set Variable | ${64}
+| | ${min_rate}= | Set Variable | ${100000}
+| | ${max_rate}= | Set Variable | ${s_18.75Mpps}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '4' worker threads and rxqueues '2' with jumbo frames 'no'
+| | Then Find NDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold}
+
+| tc14-64B-4t4c-eth-l2xcbase-testpmd-pdrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 4 threads, 4 phy\
+| | ... | cores, 2 receive queues per NIC port.
+| | ... | [Ver] Find PDR for 64 Byte frames using binary search start at 40GE\
+| | ... | linerate, step 100kpps, LT=0.5%.
+| | ...
+| | [Tags] | 4T4C | MTHREAD | PDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${64}
+| | ${min_rate}= | Set Variable | ${100000}
+| | ${max_rate}= | Set Variable | ${s_18.75Mpps}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '4' worker threads and rxqueues '2' with jumbo frames 'no'
+| | Then Find PDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold} | ${perf_pdr_loss_acceptance}
+| | ... | ${perf_pdr_loss_acceptance_type}
+
+| tc15-1518B-4t4c-eth-l2xcbase-testpmd-ndrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 4 threads, 4 phy\
+| | ... | cores, 2 receive queues per NIC port.
+| | ... | [Ver] Find NDR for 1518 Byte frames using binary search start at 40GE\
+| | ... | linerate, step 10kpps.
+| | ...
+| | [Tags] | 4T4C | MTHREAD | NDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${1518}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_24.5G} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '4' worker threads and rxqueues '2' with jumbo frames 'no'
+| | Then Find NDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold}
+
+| tc16-1518B-4t4c-eth-l2xcbase-testpmd-pdrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 4 threads, 4 phy\
+| | ... | cores, 2 receive queues per NIC port.
+| | ... | [Ver] Find PDR for 1518 Byte frames using binary search start at 40GE\
+| | ... | linerate, step 10kpps, LT=0.5%.
+| | ...
+| | [Tags] | 4T4C | MTHREAD | PDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${1518}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_24.5G} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '4' worker threads and rxqueues '2' with jumbo frames 'no'
+| | Then Find PDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold} | ${perf_pdr_loss_acceptance}
+| | ... | ${perf_pdr_loss_acceptance_type}
+
+| tc17-9000B-4t4c-eth-l2xcbase-testpmd-ndrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 4 threads, 4 phy\
+| | ... | cores, 2 receive queues per NIC port.
+| | ... | [Ver] Find NDR for 9000 Byte frames using binary search start at 40GE\
+| | ... | linerate, step 10kpps.
+| | ...
+| | [Tags] | 4T4C | MTHREAD | NDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${9000}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_24.5G} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '4' worker threads and rxqueues '2' with jumbo frames 'yes'
+| | Then Find NDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold}
+
+| tc18-9000B-4t4c-eth-l2xcbase-testpmd-pdrdisc
+| | [Documentation]
+| | ... | [Cfg] DUT runs L2 frame forwarding config with 4 threads, 4 phy\
+| | ... | cores, 2 receive queues per NIC port.
+| | ... | [Ver] Find PDR for 9000 Byte frames using binary search start at 40GE\
+| | ... | linerate, step 5kpps, LT=0.5%.
+| | ...
+| | [Tags] | 4T4C | MTHREAD | PDRDISC | SKIP_PATCH
+| | ...
+| | ${framesize}= | Set Variable | ${9000}
+| | ${min_rate}= | Set Variable | ${10000}
+| | ${max_rate}= | Calculate pps | ${s_24.5G} | ${framesize}
+| | ${binary_min}= | Set Variable | ${min_rate}
+| | ${binary_max}= | Set Variable | ${max_rate}
+| | ${threshold}= | Set Variable | ${min_rate}
+| | Given Start L2FWD '4' worker threads and rxqueues '2' with jumbo frames 'yes'
+| | Then Find PDR using binary search and pps | ${framesize} | ${binary_min}
+| | ... | ${binary_max} | 3-node-xconnect | ${min_rate} | ${max_rate}
+| | ... | ${threshold} | ${perf_pdr_loss_acceptance}
+| | ... | ${perf_pdr_loss_acceptance_type}
\ No newline at end of file
index 153fe35..0337160 100644 (file)
 | Resource | resources/libraries/robot/default.robot
 | Resource | resources/libraries/robot/interfaces.robot
 | Library | resources.libraries.python.DPDK.SetupDPDKTest
-| Suite Setup | Run Keywords | Setup DPDK Test | ${nodes}
+| Suite Setup | Run Keywords | Setup performance global Variables
+| ...         | AND          | Setup DPDK Test | ${nodes}
 | ...         | AND          | Get CPU Layout from all nodes | ${nodes}
 | ...         | AND          | Update All Numa Nodes
 | ...                        | ${nodes} | skip_tg=${True}
+
+*** Keywords ***
+| Setup performance global Variables
+| | [Documentation]
+| | ... | Setup suite Variables. Variables are used across performance testing.
+| | ...
+| | ... | _NOTE:_ This KW sets following suite variables:
+| | ... | - perf_trial_duration - Duration of traffic run [s].
+| | ... | - perf_pdr_loss_acceptance - Loss acceptance treshold
+| | ... | - perf_pdr_loss_acceptance_type - Loss acceptance treshold type
+| | ... | - perf_vm_image - Guest VM disk image
+| | ...
+| | Set Global Variable | ${perf_trial_duration} | 10
+| | Set Global Variable | ${perf_pdr_loss_acceptance} | 0.5
+| | Set Global Variable | ${perf_pdr_loss_acceptance_type} | percentage
+| | Set Global Variable | ${perf_vm_image} | /var/lib/vm/csit-nested-1.6.img
index 52b5247..68bd372 100644 (file)
@@ -273,7 +273,8 @@ class TrafficGenerator(object):
 
                 # get T-rex server info
                 (ret, _, _) = ssh.exec_command(
-                    "sh -c '{0}/resources/tools/t-rex/t-rex-server-info.py'"\
+                    "sh -c 'sleep 3; "
+                    "{0}/resources/tools/t-rex/t-rex-server-info.py'"\
                     .format(Constants.REMOTE_FW_DIR),
                     timeout=120)
                 if int(ret) == 0:
@@ -302,7 +303,7 @@ class TrafficGenerator(object):
             ssh = SSH()
             ssh.connect(node)
             (ret, stdout, stderr) = ssh.exec_command(
-                "sh -c 'sudo pkill t-rex'")
+                "sh -c 'sudo pkill t-rex && sleep 3'")
             if int(ret) != 0:
                 logger.error('pkill t-rex failed: {0}'.format(stdout + stderr))
                 raise RuntimeError('pkill t-rex failed')